SystemOrganization addCategory: #'Glamour-Helpers'!

!Boolean methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	^self! !

Object subclass: #GLMNotNilCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMNotNilCondition commentStamp: '<historical>' prior: 0!
Used to test if all defined arguments of a condition or not nil.

We use this as a default condition for presentations. Usually, you will want to define a condition as a block such as '[ :class :category | (class isKindOf: Class) and: [ category isKindOf: Symbol ] ]' (or something like that) but sometimes you just want to make sure that all arguments are defined. Since we do not know the number of arguments in advance, we use this class to interpret #glamourValueWithArgs: and return true if all arguments are not nil.!

!GLMNotNilCondition methodsFor: 'glamour' stamp: 'DamienCassou 9/10/2009 19:54'!
glamourValueWithArgs: anArray 
	 
	^anArray allSatisfy: [:each | each notNil]! !

Object subclass: #GLMPortUpdater
	instanceVariableNames: 'portSymbol valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Helpers'!

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	(anArray first pane port: self portSymbol) 
		value: (self valueBlock glamourValueWithArgs: anArray)! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
portSymbol 
	 
	^portSymbol! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
portSymbol: anObject 
	 
	portSymbol := anObject! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
valueBlock 
	 
	^valueBlock! !

!GLMPortUpdater methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
valueBlock: anObject 
	 
	valueBlock := anObject! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
asGlamorousArray 
	 
	^Array with: self! !

!Object methodsFor: '*Glamour-Helpers' stamp: 'tg 9/9/2009 01:02'!
asGlamorousMultiValue
	^ GLMMultiValue with: self! !

!Object methodsFor: '*Glamour-Helpers' stamp: 'tg 9/12/2009 01:32'!
glamourString 
	"This method tries to circumvent the missing displayString from Squeak" 
	 
	| value |
	value := (self class canUnderstand: #asString) 
		ifTrue: [self asString] 
		ifFalse: [self displayString].
	value size > 16 ifTrue: [ value := (value copyFrom: 1 to: 12), ' ...' ].	
	^ value ! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValue: anObject 
	 
	| args | 
	args := anObject asGlamorousArray. 
	^self glamourValueWithArgs: args! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	^self! !

!Object methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderObject: self! !

!Symbol methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	 
	anArray size < 1 ifTrue: [^nil]. 
	^anArray first perform: self! !

!BlockClosure methodsFor: '*Glamour-Helpers' stamp: ' 4/5/09 22:18'!
glamourValueWithArgs: anArray 
	"This is the same as valueWithPossibleArgs: from squeak. 
	Unfortunately, VW's cullValue: is incompatible." 
	 
	self numArgs = 0 ifTrue: [^self value]. 
	self numArgs = anArray size ifTrue: [^self valueWithArguments: anArray]. 
	self numArgs > anArray size 
		ifTrue: 
			[^self 
				valueWithArguments: anArray , (Array new: self numArgs - anArray size)]. 
	^self 
		valueWithArguments: 
			(anArray 
				copyFrom: 1 
				to: self numArgs)! !

!ArrayedCollection class methodsFor: '*Glamour-Helpers' stamp: 'tg 5/4/2009 22:14'!
with: anObject withAll: aCollection

	| newArray |
	newArray := self new: aCollection size + 1.
	newArray at: 1 put: anObject.
	newArray
		replaceFrom: 2
		to: newArray size
		with: aCollection.
	^newArray
	
"Array with: 1 withAll: #(2 3 4)"! !
